<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Resolving Exposed References</TITLE>
<link href="suif1_88.html" rel=Next>
<link href="suif1_86.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_86.html">previous</A>, <A HREF="suif1_88.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC87" HREF="suif1_toc.html#TOC87">Resolving Exposed References</A></H2>

<P>
<A NAME="IDX640"></A>
After the exposed references have been found, the destination scope must
be updated to include definitions for the objects in the exposed
references.  The <CODE>base_symtab</CODE> class provides the
<CODE>resolve_exposed_refs</CODE> method to accomplish this.  This method
takes the lists of original objects in the <CODE>replacements</CODE> structure
produced by the <CODE>find_exposed_refs</CODE> method (see section <A HREF="suif1_86.html#SEC86">Finding Exposed References</A>) and adds corresponding entries to the lists of new objects.
New symbols are created and added to the symbol table to replace the
originals.  Variable definitions are also created as needed.

</P>
<P>
Because some types use name equivalence, they cannot be copied without
creating different types.  Thus, whenever possible, types are moved up
in the symbol table hierarchy so that they are visible in both the
source and destination scopes.  If a type is successfully moved, the old
and new entries for the <CODE>replacements</CODE> lists are the same.  Some
types contain references to variables (e.g. as array bounds), and if
those variables are not already visible in the destination scope, the
types cannot be moved.  When that happens, <CODE>resolve_exposed_refs</CODE>
resorts to making a new type where the variable references are updated
to use the cloned variables.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_86.html">previous</A>, <A HREF="suif1_88.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
